---
title: 聊聊电商促销业务
---

#  聊聊电商促销业务


> 作者：Tom哥
> <br/>公众号：微观技术
> <br/> 博客：[https://offercome.cn](https://offercome.cn)
> <br/> 人生理念：知道的越多，不知道的越多，努力去学


促销是电商领域非常重要的营销手段，有效提高订单转化率、客单价、网站的GMV交易额。


早年的促销更多是线下玩法，但随着互联网深入我们生活的方方面面，越来越多的促销开始搬到了线上，并且玩出了很多新的花样。促销规则也开始复杂化、多样化。


## 促销的目的


* 拉新。可以吸引很多新用户到平台注册。
* 清库存。降低库存的仓储成本
* 提升品牌效应。
* 推广新品。借助促销流量，给新品更多的曝光流量。
* 与竞品抢生意。毕竟市场就那么多，一个用户想买个苹果手机，如果选择了淘宝，可能就不会在京东下单。
* 提高客单价，网站GMV。每年淘宝双11，就是各种优惠券、津贴、红包、促销活动组合玩法，给用户营造一种有便宜可占的氛围。



## 促销活动主要由三部分组成


### 1、基础设置

像活动名称、活动id、活动时间、推广平台、促销渠道、用户范围、推广链接等


### 2、促销规则

针对不同类型的活动，会有不同的活动规则，直接影响订单的优惠计算。


### 3、活动商品

设置促销活动商品范围时，可以选择全部商品或部分商品。有赠品的促销活动还要选择配置赠品。



## 促销规则

* 满减促销。又可以细化为三种形式：单次满减、每满减、阶梯满减。单次满减，如满100减10，订单330需要实付320。每满减，如每满100减10，订单330需要实付300。阶梯满减，如满100减10、满200减30、满300减50。
* 单品促销。可以分为单品特定价、单品满减（分为数量、金额）、单品打折（分为数量、金额）
* 组合促销。将商品组合按优惠价出售。例如：A商品70元，B商品50元，组合来卖100元
* 赠品促销。购买主商品之后赠送商品。对于赠品，也有多种赠送方式，全部赠送或者选一件赠品。例如：卖手机送手机壳
* 满赠促销。购买商品满足X元后送某商品，或者购买商品金额满X元后再加价Y元送某商品。
* 多买优惠促销。例如：全场10元2件，2件8折
* 定金促销。采用预付定金的模式，提前交定金可以享受优惠价。定金杠杆，例如：充100抵150


不同的促销模式有适合自己的应用场景，也能衍生不一样的玩法，如果组合起来，营销效果会更好。

促销活动作为一堆商品的聚合，通常以会场H5页面来承载，借助资源位来定位透出。此外在商品详情页、购物车、下单页也会透出。此外还应考虑活动商品在订单结算时的计算规则、优惠分摊。


## 促销活动管理


1、创建活动

2、审核活动

> 活动创建之后，为了满足安全性，通常工作流程上会增加审核机制。只有审核通过才能上线。

3、编辑活动

4、删除活动

> 促销活动的状态机一般有“未开始”、“进行中”、“已结束”、“已删除”


## 优惠计算


涉及促销商品计算的主要是两个地方：购物车、订单计算。


<div align="left">
    <img src="https://offercome.cn/images/arch/business/7-1.png" width="560px">
</div>


如果一个商品参加多种促销活动时，一般按最优原则，自动选择最佳优惠方案计算。


## 注意事项

* 策划促销活动，需要提前核算运营活动成本，以及预估活动的效果，选择最佳的促销手段。
* 提前做安全评估，严防薅羊毛事件发生。
* 为了验证活动效果，可以做 A/B Test

## 促销活动架构图


<div align="left">
    <img src="https://offercome.cn/images/arch/business/7-2.png" width="660px">
</div>
