---
title: 你离职的原因是什么？如何避坑？
---

#  你离职的原因是什么？如何避坑？

> 作者：Tom哥
> <br/>公众号：微观技术
> <br/> 博客：[https://offercome.cn](https://offercome.cn)
> <br/> 人生理念：知道的越多，不知道的越多，努力去学



大家好，我是Tom哥

疫情肆虐，经济下行。整个互联网行业到处都在裁员、续命。

<div align="left">
    <img src="https://offercome.cn/images/interview/skill/6-2.jpeg" width="250px">
</div>

在网上看到一些数据，短短几个月时间，互联网头部大厂已经优化释放了十几万人才，打工人太难了。

无论多不情愿，这就是生活，很多人被迫再次踏上找工作的残酷厮杀。

作为一名优秀程序员过五关斩六将，好不容易进入了 HR 环节，如果因为自己的`天真`导致面试失败，那太可惜了。

HR 环节，经常会问一个致命问题：你从上一家离职的原因是什么？

<div align="left">
    <img src="https://offercome.cn/images/interview/skill/6-3.jpeg" width="250px">
</div>

今天我们就将常见的离职原因做下汇总，看看`高情商`是如何来回答的


## 老板给的工资太低了

很多同学会直言老板抠门，工作3年了，工资低且没有涨过薪资，年终奖更是少的可怜

这种回答，给人有种过于 `金钱观`感觉，虽然马斯诺理论说过，`生理需求`是最基本的，但是谈钱总是容易伤感情。

我们可以讲：

我在原公司的平台上已经积累了很多，希望找一个新的平台，开阔下视野，将能力迈向一个新的台阶。换个角度来回答这个问题，不要把注意力只盯在钱上。



## 工作量太大，老是加班

千万不要直言是因为加班才导致自己的离职，很容易让 HR 怀疑你的工作效率太低。同事间的横向沟通或者向上管理的能力太差。

我们可以讲：

如果是因为受不了加班安排离职，最好能具体列举一些加班的超常规细节。比如：公司的加班时间有些特殊，总是在下班后开会，连续2个多月工作到晚上12点以后，加班的强度超出了常人所能承受范围。最好描述整个团队都是这个情况，避免被针对性。

如果担心这样回答不好，也可以换个角度。频繁的业务创新，导致大量的 `CRUD` 重复性低效工作，个人成就感低，希望找一个高质量的平台，能有一些解决挑战性难题的机会


## 小人太多，工作中太多扯皮、甩锅事件

扯皮、甩锅、办公室政治，很多公司都存在。

无非是否严重到影响到员工的正常输出，劣币驱逐良币。

我们可以委婉讲：

自己注重团队氛围，感觉原公司不太适合我，所以选择离开。我认为一个良好的工作氛围能够提供高的工作效率，明确的分工和相对完善的制度是提高生产力的基本保障。


## 老板水平太菜

如果是这个原因，可千万别实话实说，不要随意评判一个人，尤其这个人还是你的老板。

很容易让 HR 误认为你这人很主观、自以为是，容易被 pass

我们换种表达：

在原来的岗位已经学到了很多，能力也有了极大提升。希望出来开阔下自己的视野，拓宽自己的技术面，让自己收获更大的成长。

## 工作太闲了

这种情况与当下盛行的 `996`、`007` 显得格格不入。但是有些国企或事业单位，工作节奏会缓和一些，平时也不太用加班。

但是我们也千万不能太实诚了，一激动，实话实说

我们可以讲：

我是一个不安于现状的人，作为年轻人应该勇于拼搏，主动积极承担更多，让自己成长的更快。主要是把自己的积极性、主动性表现出来。


## 公司的管理制度太苛刻

比如早上要打卡，晚上又要强制各种加班

我们可以讲：

我非常欣赏贵公司的人性化工作管理，靠成果说话，在这种环境下更能激发我的主观能动性。


## 之前的公司没有发展前途

很多候选人将离职原因归咎到公司，显得自己没有问题。正如一个巴掌拍不响，任何事情都是有关联的。HR 心里可能会想，那为什么你当初还选这家公司？说明你的眼光也不怎么样。要不就是你的能力也不怎么样，在公司的业务发展中，助力太少。

我们可以讲：

自己的职业发展路线与公司的发展规划不符，所以选择离职。重点讲下自己在原公司的具体业绩情况，但因公司的晋升通道、部门调整等因素造成了发展路线偏差，所以离开，千万不可以说公司没前途。


在原来的平台，感觉自身积累的能力已经成熟，希望能够拓宽自己的知识面，更深入地学习和实践。


## 怀才不遇，不被公司重视

这个我们最好不要实话实说，很容易让 HR 感觉你`恃才傲物`，`自命清高`。容易留下差印象。

我们可以讲：

原来的平台已经基本稳定，个人发挥的空间越来越少，不想再留下去混日子，希望找个更大的平台，参与更多有挑战的事情，收获更大的成长。

也可以从经济角度出发，比如，一两年内想买房，有比较大的开销，需要增加工资收入。但是自己肯努力，肯付出，在新的岗位一定能创造更多的价值。


## 最后

不管是什么原因离职的都可以加上一句，不管怎么样，我都很感恩上家公司，让我学到了很多，对行业和岗位有了更深的理解，让我有信心开启下一段新的职场。


