---
title: 第十七篇：操作系统！内核态、虚拟内存、分页、IO模型
---

# 操作系统那点破事！内核态、虚拟内存、分页、IO模型

> 作者：Tom哥
> <br/>公众号：微观技术
> <br/> 博客：[https://offercome.cn](https://offercome.cn)
> <br/> 人生理念：知道的越多，不知道的越多，努力去学


## **并行与并发的区别？**<br /><br />
答案：<br />从操作系统的角度来看，线程是CPU分配的最小单位。<br />1、并行就是同一时刻，两个线程都在执行。要求有两个CPU去分别执行两个线程。<br />2、并发就是同一时刻，只有一个执行，但是一个时间段内，两个线程都执行了。并发的实现依赖于CPU切换线程，因为切换的时间特别短，所以基本对于用户是无感知的。

## 进程和线程的区别？

答案：

- 调度：进程是资源管理的基本单位，线程是程序执行的基本单位。
- 切换：线程上下文切换比进程上下文切换要快得多。
- 拥有资源： 进程是拥有资源的一个独立单位，线程不拥有系统资源，但是可以访问隶属于进程的资源。
- 系统开销： 创建或撤销进程时，系统都要为之分配或回收系统资源，如内存空间，I/O设备等，OS 所付出的开销显著大于在创建或撤销线程时的开销，进程切换的开销也远大于线程切换的开销。

## 线程与协程的区别？

答案：

- 线程和进程都是同步机制，而协程是异步机制。
- 线程是抢占式，而协程是非抢占式的。需要用户释放使用权切换到其他协程，因此同一时间其实只有一个协程拥有运行权，相当于单线程的能力。
- 一个线程可以有多个协程，一个进程也可以有多个协程。
- 协程不被操作系统内核管理，而完全是由程序控制。线程是被分割的CPU资源，协程是组织好的代码流程，线程是协程的资源。但协程不会直接使用线程，协程直接利用的是执行器关联任意线程或线程池。
- 协程能保留上一次调用时的状态

## 进程与线程的切换流程？<br /><br />
答案： <br />进程切换分两步：<br />1、切换页表以使用新的地址空间，一旦去切换上下文，处理器中所有已经缓存的内存地址一瞬间都作废了。<br />2、切换内核栈和硬件上下文。<br />对于linux来说，线程和进程的最大区别就在于地址空间，对于线程切换，第1步是不需要做的，第2步是 进程和线程切换都要做的。<br />因为每个进程都有自己的虚拟地址空间，而线程是共享所在进程的虚拟地址空间的，因此同一个进程中 的线程进行线程切换时不涉及虚拟地址空间的转换。

## 为什么虚拟地址空间切换会比较耗时？<br /><br />
答案： <br />进程都有自己的虚拟地址空间，把虚拟地址转换为物理地址需要查找页表，页表查找是一个很慢的过 程，因此通常使用Cache来缓存常用的地址映射，这样可以加速页表查找，这个Cache就是 TLB（translation Lookaside Buffer，TLB本质上就是一个Cache，是用来加速页表查找的）。 由于每个进程都有自己的虚拟地址空间，那么显然每个进程都有自己的页表，那么当进程切换后页表 也要进行切换，页表切换后TLB就失效了，Cache失效导致命中率降低，那么虚拟地址转换为物理地 址就会变慢，表现出来的就是程序运行会变慢，而线程切换则不会导致TLB失效，因为线程无需切换地 址空间，因此我们通常说线程切换要比较进程切换块，原因就在这里

## 进程间通信方式有哪些？
 <br />答案：<br />1、管道<br />管道这种通讯方式有两种限制，一是半双工的通信，数据只能单向流动，二是只能在具有亲缘关系的进程间使用。进程的亲缘关系通常是指父子进程关系。<br />管道可以分为两类：匿名管道和命名管道。匿名管道是单向的，只能在有亲缘关系的进程间通信； 命名管道以磁盘文件的方式存在，可以实现本机任意两个进程通信。<br />2、信号 <br />信号是一种比较复杂的通信方式，信号可以在任何时候发给某一进程，而无需知道该进程的状态。   <br />**Linux系统中常用信号：**
:::info
（1）SIGHUP：用户从终端注销，所有已启动进程都将收到该进程。系统缺省状态下对该信号的处理是终止进程。<br />（2）SIGINT：程序终止信号。程序运行过程中，按 Ctrl+C 键将产生该信号。<br />（3）SIGQUIT：程序退出信号。程序运行过程中，按 Ctrl+\\ 键将产生该信号。<br />（4）SIGBUS和SIGSEGV：进程访问非法地址。<br />（5）SIGFPE：运算中出现致命错误，如除零操作、数据溢出等。<br />（6）SIGKILL：用户终止进程执行信号。shell下执行 kill -9 发送该信号。<br />（7）SIGTERM：结束进程信号。shell下执行 kill 进程pid 发送该信号。<br />（8）SIGALRM：定时器信号。<br />（9）SIGCLD：子进程退出信号。如果其父进程没有忽略该信号也没有处理该信号，则子进程退出后将形成僵尸进程。
:::

3、信号量：信号量是一个计数器，可以用来控制多个进程对共享资源的访问。它常作为一种锁机制，防止某进程正在访问共享资源时，其他进程也访问该资源。因此，主要作为进程间以及同一进程内不同线程之间的同步手段。<br />4、消息队列：消息队列是消息的链接表，包括Posix消息队列和System V消息队列。有足够权限的进程可以向队列中添加消息，被赋予读权限的进程则可以读走队列中的消息。消息队列克服了信号承载信息量少，管道只能承载无格式字节流以及缓冲区大小受限等缺点。<br />5、共享内存：共享内存就是映射一段能被其他进程所访问的内存，这段共享内存由一个进程创建，但多个进程都可以访问。共享内存是最快的 IPC 方式，它是针对其他进程间通信方式运行效率低而专门设计的。它往往与其他通信机制，如信号量，配合使用，来实现进程间的同步和通信。<br />6、Socket：与其他通信机制不同的是，它可用于不同机器间的进程通信。 

  **优缺点：**

- 管道：速度慢，容量有限；
- Socket：任何进程间都能通讯，但速度慢；
- 消息队列：容量受到系统限制，且要注意第一次读的时候，要考虑上一次没有读完数据的问题；
- 信号量：不能传递复杂消息，只能用来同步；
- 共享内存区：能够很容易控制容量，速度快，但要保持同步，比如一个进程在写的时候，另一个进程要注意读写的问题，相当于线程中的线程安全，当然，共享内存区同样可以用作线程间通讯，不过没这个必要，线程间本来就已经共享了同一进程内的一块内存

## 线程同步的方式有哪些？<br /><br />
答案：<br />1、临界区：当多个线程访问一个独占性共享资源时，可以使用临界区对象。拥有临界区的线程可以访问 被保护起来的资源或代码段，其他线程若想访问，则被挂起，直到拥有临界区的线程放弃临界区为止， 以此达到用原子方式操 作共享资源的目的。 <br />2、事件：事件机制，则允许一个线程在处理完一个任务后，主动唤醒另外一个线程执行任务。 <br />3、互斥量：互斥对象和临界区对象非常相似，只是其允许在进程间使用，而临界区只限制与同一进程的 各个线程之间使用，但是更节省资源，更有效率。 <br />4、信号量：当需要一个计数器来限制可以使用某共享资源的线程数目时，可以使用“信号量”对象。 <br />**区别：**

- 互斥量与临界区的作用非常相似，但互斥量是可以命名的，也就是说互斥量可以跨越进程使用，但创建互斥量需要的资源更多，所以如果只为了在进程内部使用的话使用临界区会带来速度上的优势并能够减少资源占用量 。因为互斥量是跨进程的互斥量一旦被创建，就可以通过名字打开它。
- 互斥量，信号量，事件都可以被跨越进程使用来进行同步数据操作。

## 线程的分类？<br /><br />
答案： <br />从线程的运行空间来说，分为用户级线程（user-level thread, ULT）和内核级线程（kernel-level, KLT）

**内核级线程**：这类线程依赖于内核，又称为内核支持的线程或轻量级进程。无论是在用户程序中的线程 还是系统进程中的线程，它们的创建、撤销和切换都由内核实现。比如英特尔i5-8250U是4核8线程，这里的线程就是内核级线程 <br />**用户级线程**：它仅存在于用户级中，这种线程是不依赖于操作系统核心的。应用进程利用线程库来完 成其创建和管理，速度比较快，操作系统内核无法感知用户级线程的存在。

## 什么是临界区，如何解决冲突？<br /><br />
答案：<br />每个进程中访问临界资源的那段程序称为临界区，一次仅允许一个进程使用的资源称为临界资源。<br />**解决冲突的办法：**

- 如果有若干进程要求进入空闲的临界区，一次仅允许一个进程进入，如已有进程进入自己的临界区，则其它所有试图进入临界区的进程必须等待；
- 进入临界区的进程要在有限时间内退出。
- 如果进程不能进入自己的临界区，则应让出CPU，避免进程出现“忙等”现象。

## 进程调度策略有哪几种？<br /><br />
答案：<br />1、先来先服务：非抢占式的调度算法，按照请求的顺序进行调度。有利于长作业，但不利于短作业，因为短作业必须一直等待前面的长作业执行完毕才能执行，而长作业又需要执行很长时间，造成了短作业等待时间过长。另外，对 I/O 密集型进程也不利，因为这种进程每次进行 I/O 操作之后又得重新排队。<br />2、短作业优先：非抢占式的调度算法，按估计运行时间最短的顺序进行调度。长作业有可能会饿死，处于一直等待短作业执行完毕的状态。因为如果一直有短作业到来，那么长作业永远得不到调度。 <br />3、最短剩余时间优先：最短作业优先的抢占式版本，按剩余运行时间的顺序进行调度。 当一个新的作业到达时，其整个运行时间与当前进程的剩余时间作比较。如果新的进程需要的时间更少，则挂起当前进程，运行新的进程。否则新的进程等待。 <br />4、时间片轮转：将所有就绪进程按 FCFS 的原则排成一个队列，每次调度时，把 CPU 时间分配给队首进程，该进程可以执行一个时间片。当时间片用完时，由计时器发出时钟中断，调度程序便停止该进程的执行，并将它送往就绪队列的末尾，同时继续把 CPU 时间分配给队首的进程。<br />时间片轮转算法的效率和时间片的大小有很大关系：因为进程切换都要保存进程的信息并且载入新进程的信息，如果时间片太小，会导致进程切换得太频繁，在进程切换上就会花过多时间。 而如果时间片过长，那么实时性就不能得到保证。 <br />5、优先级调度：为每个进程分配一个优先级，按优先级进行调度。为了防止低优先级的进程永远等不到调度，可以随着时间的推移增加等待进程的优先级。

## 什么是分页？

答案：<br />把内存空间划分为大小相等且固定的块，作为主存的基本单位。因为程序数据存储在不同的页面中，而页面又离散的分布在内存中，因此需要一个页表来记录映射关系，以实现从页号到物理块号的映射。

访问分页系统中内存数据需要两次的内存访问 (一次是从内存中访问页表，从中找到指定的物理块号，加上页内偏移得到实际物理地址；第二次就是根据第一次得到的物理地址访问内存取出数据)。 <br />![](https://cdn.nlark.com/yuque/0/2022/png/21503536/1666970914486-34c04db3-564b-467f-90c2-e59abaae7343.png#clientId=ud43f3112-c817-4&from=paste&height=354&id=u78513d20&originHeight=800&originWidth=1308&originalType=url&ratio=1&rotation=0&showTitle=false&status=done&style=none&taskId=u061daaf4-a23d-40cb-9626-1b420dda9a7&title=&width=578)

## 什么是分段？<br /><br />
答案： <br />分页是为了提高内存利用率，而分段是为了满足程序员在编写代码的时候的一些逻辑需求(比如数据共享，数据保护，动态链接等)。<br /> 分段内存管理当中，地址是二维的，一维是段号，二维是段内地址；其中每个段的长度是不一样的，而且每个段内部都是从0开始编址的。由于分段管理中，每个段内部是连续内存分配，但是段和段之间是离散分配的，因此也存在一个逻辑地址到物理地址的映射关系，相应的就是段表机制。

![](https://cdn.nlark.com/yuque/0/2022/png/21503536/1666970914524-2535ce8c-5227-4f00-8bfa-a64dccb70332.png#clientId=ud43f3112-c817-4&from=paste&height=265&id=u22abe2a9&originHeight=594&originWidth=1360&originalType=url&ratio=1&rotation=0&showTitle=false&status=done&style=none&taskId=u1482e205-62a8-4492-95a0-101791b3dac&title=&width=607)

## 分页和分段有什区别？<br /><br />
答案：

- 分页对程序员是透明的，但是分段需要程序员显式划分每个段。
- 分页的地址空间是一维地址空间，分段是二维的。
- 页的大小不可变，段的大小可以动态改变。
- 分页主要用于实现虚拟内存，从而获得更大的地址空间；分段主要是为了使程序和数据可以被划分为逻辑上独立的地址空间并且有助于共享和保护。

## 什么是交换空间？<br /><br />
答案：<br />操作系统把物理内存(physical RAM)分成一块一块的小内存，每一块内存被称为页(page)。当内存资源不足时，Linux把某些页的内容转移至硬盘上的一块空间上，以释放内存空间。硬盘上的那块空间叫做交换空间(swap space)，而这一过程被称为交换(swapping)。物理内存和交换空间的总容量就是虚拟内存的可用容量。<br />**用途：**

- 物理内存不足时一些不常用的页可以被交换出去，腾给系统。
- 程序启动时很多内存页被用来初始化，之后便不再需要，可以交换出去。

## 页面替换算法有哪些？<br /><br />
答案： <br />在程序运行过程中，如果要访问的页面不在内存中，就发生缺页中断从而将该页调入内存中。此时如果内存已无空闲空间，系统必须从内存中调出一个页面到磁盘对换区中来腾出空间。 <br />![](https://cdn.nlark.com/yuque/0/2022/png/21503536/1666970914503-bdfac9c2-7593-4fe8-a5d6-51940219b141.png#clientId=ud43f3112-c817-4&from=paste&id=u98d9d25e&originHeight=756&originWidth=1432&originalType=url&ratio=1&rotation=0&showTitle=false&status=done&style=none&taskId=u193dba0f-050c-430c-86b4-72c2aed0713&title=)

- 最优算法 在当前页面中置换最后要访问的页面。不幸的是，没有办法来判定哪个页面是最后一个要访问的， 因此实际上该算法不能使用 。然而，它可以作为衡量其他算法的标准。
- NRU 算法根据 R 位和 M 位的状态将页面分为四类。从编号最小的类别中随机选择一个页面。NRU算法易于实现，但是性能不是很好。存在更好的算法。
- FIFO 会跟踪页面加载进入内存中的顺序，并把页面放入一个链表中。有可能删除存在时间最长但是还在使用的页面，因此这个算法也不是一个很好的选择。
- 第二次机会 算法是对 FIFO 的一个修改，它会在删除页面之前检查这个页面是否仍在使用。如果页面正在使用，就会进行保留。这个改进大大提高了性能。
- 时钟 算法是第二次机会算法的另外一种实现形式，时钟算法和第二次算法的性能差不多，但是会花费更少的时间来执行算法。
- LRU 算法是一个非常优秀的算法，但是没有 特殊的硬件(TLB) 很难实现。如果没有硬件，就不能使用 LRU 算法。
- NFU 算法是一种近似于 LRU 的算法，它的性能不是非常好。
- 老化 算法是一种更接近 LRU 算法的实现，并且可以更好的实现，因此是一个很好的选择
- 最后两种算法都使用了工作集算法。工作集算法提供了合理的性能开销，但是它的实现比较复杂。WSClock 是另外一种变体，它不仅能够提供良好的性能，而且可以高效地实现。

最好的算法是老化算法和WSClock算法。他们分别是基于 LRU 和工作集算法。他们都具有良好的性能 并且能够被有效的实现。还存在其他一些好的算法，但实际上这两个可能是最重要的

## 什么是缓冲区溢出？<br /><br />
答案：<br />缓冲区溢出是指当计算机向缓冲区填充数据时超出了缓冲区本身的容量，溢出的数据覆盖在合法数据 上。<br />**危害有以下两点：**

- 程序崩溃，导致拒绝额服务
- 跳转并且执行一段恶意代码

造成缓冲区溢出的主要原因是程序中没有仔细检查用户输入。

## 什么是虚拟内存？ 

答案：<br />虚拟内存就是说，让物理内存扩充成更大的逻辑内存，从而让程序获得更多的可用内存。虚拟内存使用部分加载的技术，让一个进程或者资源的某些页面加载进内存，从而能够加载更多的进程，甚至能加载比内存大的进程，这样看起来好像内存变大了，这部分内存其实包含了磁盘或者硬盘，并且就叫做虚拟内存。

## 虚拟内存的实现方式?


答案：<br />虚拟内存中，允许将一个作业分多次调入内存。釆用连续分配方式时，会使相当一部分内存空间都处于暂时或 永久 的空闲状态，造成内存资源的严重浪费，而且也无法从逻辑上扩大内存容量。因此，虚拟内存的实需要建立在离散分配的内存管理方式的基础上。

**虚拟内存的实现有以下三种方式：**

- 请求分页存储管理
- 请求分段存储管理
- 请求段页式存储管理

## 硬链接和软链接有什么区别？<br /><br />
答案：<br />1、硬链接就是在目录下创建一个条目，记录着文件名与 inode 编号，这个 inode 就是源文件的 inode 。删除任意一个条目，文件还是存在，只要引用数量不为 0 。但是硬链接有限制，它不能跨越文件系统，也不能对目录进行链接。<br />2、符号链接文件保存着源文件所在的绝对路径，在读取时会定位到源文件上，可以理解为 Windows 的快捷方式。当源文件被删除了，链接文件就打不开了。因为记录的是路径，所以可以为目录建立符号链接。

## 中断的处理过程?<br /><br />
答案： <br />1、保护现场：将当前执行程序的相关数据保存在寄存器中，然后入栈。 <br />2、开中断：以便执行中断时能响应较高级别的中断请求。 <br />3、中断处理 <br />4、关中断：保证恢复现场时不被新中断打扰 <br />5、恢复现场：从堆栈中按序取出程序数据，恢复中断前的执行状态。

## 中断和轮询的区别？

答案： <br />轮询：CPU对特定设备轮流询问。中断：通过特定事件提醒CPU。 <br />轮询：效率低等待时间长，CPU利用率不高。中断：容易遗漏问题，CPU利用率不高

## 什么是用户态和内核态？ 

答案：<br />1、内核态：内核态运行的程序可以访问计算机的任何数据和资源，不受限制，包括外围设备，比如网卡、硬盘等。处于内核态的 CPU 可以从一个程序切换到另外一个程序，并且占用 CPU 不会发生抢占情况。<br /> 2、用户态：用户态运行的程序只能受限地访问内存，只能直接读取用户程序的数据，并且不允许访问外围设备，用户态下的 CPU 不允许独占，也就是说 CPU 能够被其他程序获取。

将操作系统的运行状态分为用户态和内核态，主要是为了对访问能力进行限制，防止随意进行一些比较 危险的操作导致系统的崩溃，比如设置时钟、内存清理，这些都需要在内核态下完成 。

## 用户态和内核态是如何切换?<br /><br />
答案：<br />所有的用户进程都是运行在用户态的，但是我们上面也说了，用户程序的访问能力有限，一些比较重要的比如从硬盘读取数据，从键盘获取数据的操作则是内核态才能做的事情，而这些数据却又对用户程序来说非常重要。所以就涉及到两种模式下的转换，即用户态 -> 内核态 -> 用户态，而唯一能够做这些操作的只有 系统调用 ，而能够执行系统调用的就只有 操作系统 。 <br />一般用户态 -> 内核态的转换我们都称之为 trap 进内核，也被称之为 陷阱指令(trap instruction) 。<br />**工作流程如下：**

![](https://cdn.nlark.com/yuque/0/2022/png/21503536/1666970914429-bb76fe5f-f48f-4d5d-b781-562b65c30140.png#clientId=ud43f3112-c817-4&from=paste&height=411&id=ud13f8655&originHeight=1028&originWidth=1412&originalType=url&ratio=1&rotation=0&showTitle=false&status=done&style=none&taskId=u373b3ea9-7ccd-4e29-8b26-8f3e3677de7&title=&width=564)

- 首先用户程序会调用 glibc 库，glibc 是一个标准库，同时也是一套核心库，库中定义了很多关键 API。
- glibc 库知道针对不同体系结构调用 系统调用 的正确方法，它会根据体系结构应用程序的二进制接口设置用户进程传递的参数，来准备系统调用。
- 然后，glibc 库调用 软件中断指令(SWI) ，这个指令通过更新 CPSR 寄存器将模式改为超级用户模式，然后跳转到地址 0x08 处。
- 到目前为止，整个过程仍处于用户态下，在执行 SWI 指令后，允许进程执行内核代码，MMU 现在 允许内核虚拟内存访问
- 从地址 0x08 开始，进程执行加载并跳转到中断处理程序，这个程序就是 ARM 中的 vector_swi() 
- 在 vector_swi() 处，从 SWI 指令中提取系统调用号 SCNO，然后使用 SCNO 作为系统调用表sys_call_table 的索引，调转到系统调用函数。
- 执行系统调用完成后，将还原用户模式寄存器，然后再以用户模式执行。

## 常见的IO模型？<br /><br />
答案：<br />1、同步阻塞式IO模型<br />2、非阻塞式IO模型<br />3、IO 复用式IO模型<br />4、信号驱动式IO模型<br />5、异步IO式IO模型

## select、poll 和 epoll 的区别?<br /><br />
答案： <br />1、select：时间复杂度 O(n)<br />select 仅仅知道有 I/O 事件发生，但并不知道是哪几个流，所以只能无差别轮询所有流，找出能读出数据或者写入数据的流，并对其进行操作。所以 select 具有 O(n) 的无差别轮询复杂度，同时处理的流越 多，无差别轮询时间就越长。 <br />2、poll：时间复杂度 O(n)<br />poll 本质上和 select 没有区别，它将用户传入的数组拷贝到内核空间，然后查询每个 fd 对应的设备状态， 但是它没有最大连接数的限制，原因是它是基于链表来存储的。 <br />3、epoll：时间复杂度 O(1)<br />epoll 可以理解为 event poll，不同于忙轮询和无差别轮询，epoll 会把哪个流发生了怎样的 I/O 事件通 知我们。所以说 epoll 实际上是事件驱动（每个事件关联上 fd）的。

> select，poll，epoll 都是 IO 多路复用的机制。I/O 多路复用就是通过一种机制监视多个描述符， 一旦某个描述符就绪（一般是读就绪或者写就绪），就通知程序进行相应的读写操作。但 select， poll，epoll 本质上都是同步 I/O，因为他们都需要在读写事件就绪后自己负责进行读写，也就是说 这个读_写过程是阻塞的，而异步 I/O 则无需自己负责进行读_写，异步 I/O 的实现会负责把数据从内 核拷贝到用户空间

