---
title: 第六篇：面试！面试技巧、职业规划、谈薪资
pay: https://articles.zsxq.com/id_rt5v260knmsw.html
---

# 面试那点破事！面试技巧、职业规划、谈薪资

> 作者：Tom哥
> <br/>公众号：微观技术
> <br/> 博客：[https://offercome.cn](https://offercome.cn)
> <br/> 人生理念：知道的越多，不知道的越多，努力去学



## 如何写简历？

答案：

面试官每天可能看几十上百封简历，一定让自己的简历突出，才能在茫茫人海中抓人眼球。

**一封优秀的简历有以下几个特点：**

- 排版一定要工整，不要搞些花里胡哨的东西 
- 中文和数字英文之间加上空格的话看起来会舒服一点
- 工作经历最好采用时间倒序排序，毕竟面试官关心的是最新的工作内容。
- 项目经历要简明扼要，避免长篇大论，关键突出自己的亮点。项目不在于多而在于精。
- 面试官一般是参照简历中的项目展开询问，所以简历上的内容一定要非常熟悉。比如，你写了高并发的项目经历，面试官大概率会很感兴趣围绕了高并发展开考察。
- 简历上不建议标注薪资
- 简历一定要真实，不要写自己不会的东西，或者带有欺骗性的东西

> 特别注意，作为一名技术人，简历中提到的技术术语一定要规范，给人一种很专业的感觉。比如：MySQL不要写成mysql，Java不要写成 java


## 简历包含哪些内容？

答案：

**1、个人信息**

主要包含姓名、电话、邮箱、籍贯、学历等个人基本信息。

**2、求职意向**

主要是个人的求职岗位，如：资深研发工程师、架构师、技术总监、团队负责人等

**3、教育经历**

主要包含起止时间、学校、专业、学历等

**4、专业技能**
这个是简历中的核心，是你的技术画像，可以让面试官先对你有个初步了解，你的技术方向，擅长点，是否满足求职岗位的需求。
在描述自己的专业技能时，结合自身情况，合理使用“了解、熟悉、精通” 等层级，保证真实，不要夸大

<div align="left">
    <img src="http://offercome.cn/images/article/interview/interview/6-1.png" width="800px">
</div>

**5、工作经历**

主要是在每家公司任职的起始时间、公司名称、工作岗位，以及概要描述下主要工作内容

注意：一定要真实，现在大部分公司发offer前都会进行背调，如果有造假，很容易被发现。

<div align="left">
    <img src="http://offercome.cn/images/article/interview/interview/6-2.png" width="800px">
</div>


**6、项目经历**

主要分为三小块内容。

- 项目描述。用简练的语言描述下项目核心内容，让面试官对这个项目有一个快速了解，方面你后面展开交流时，频道能对齐，不至于鸡同鸭讲
> 很多候选人感觉面试挺顺畅的，问题也都答上来了，最后却没了下文。很大一部分就是沟通没对齐，直白来讲，就是你一个人在那自 hign。
> 你仔细想想，如果面试官都没听懂你在说什么？又怎么能断定你很优秀，最后还不是被pass掉。

- 技术栈。如：spring boot、dubbo、kafka、redis、es、cobar、mysql 等
- 职责描述。主要是讲你在项目中承担什么角色，负责哪些功能模块的技术方案设计、代码开发等。

同时最好能列举几个有挑战的技术难点及解决方案，描述要言简意赅，不要搞成流水账，具体细节可以在面试时展开交流

**加分项（**项目亮点**）**，比如：

- 经过你的优化改造后，QSP 提升了多少；RT 降低了多少；
- 研发效率提升了多少；研发成本降低了多少；
- 系统扩展性方面有哪些优化？类似业务开发接入时间由之前的10天降为现在的2天
- 负责双十一大促营销活动的方案设计，单日 GMV 成交 1个亿 +
- 描述事项的关键点，从 0 到 1 搭建系统
- 负责 「营销系统」演进的架构设计
- 支持了社区的「 Feed 流动态」从 1.0 到 2.0 的升级
- 其他有挑战的事情（值得拿出来show）

> 该部分是整个面试过程的重点，面试官大部分时间是围绕着你参与的项目展开考察。
> 所以项目一定要非常熟悉，面试前最好在脑海中对简历里的项目像放电影一样做下复盘，清晰的还原当时的整个过程，加深印象。


**7、其他**

- 个人评价，如：良好的表达能力、沟通能力、团队协助能力、抗压能力等
- 个人获奖荣誉，如：自己的博客、参与开源框架 pr、发表的专利、学术论文、ACM竞赛获奖、之前公司拿过的一些荣誉奖项等
- 如果自己的 Github 活跃，也可以写上


## 如何自我介绍？


答案：

1、面带微笑，充满自信，控制好说话的语速，可以适当慢一点。注意把控好时间节奏，最好控制在3到5分钟

2、简单介绍下个人履历，呆过哪些公司，哪些岗位，负责过哪些事情，简历中的一些亮点项目可以在这里简单提下，吸引面试官的兴趣，为后面的深入面谈埋下伏笔。尤其是最近的项目可以重点介绍下。

3、工作中取得过什么业绩，个人收获哪些成长。适当拔下高度，比如：关注业务，主动思考技术如何更好的服务业务；有大局观，当面临团队合作不顺畅时，不计较个人得失，更关注公司层面拿结果。

4、个人的兴趣爱好，最好与工作相关。比如：阅读、写博客等

5、结束语，自我评价，比如：团队协助能力、拿结果能力。最好与面试的公司做下关联，非常喜欢 ××× 公司，××× 业务，巧妙的拉近与面试官的关系。

> 注意：核心是show 出自己的技术实力，擅长的技能，做过的一些成功的事情。

