---
title: 基础篇：为什么流量入口要部署网关？
pay: https://articles.zsxq.com/id_bvt9t3l3lpdi.html
---

#  基础篇：为什么流量入口要部署网关？


> 作者：Tom哥
> <br/>公众号：微观技术
> <br/> 博客：[https://offercome.cn](https://offercome.cn)
> <br/> 人生理念：知道的越多，不知道的越多，努力去学


互联网时代为了解决复杂的业务问题，我们一般都会采用`微服务架构`。将一个大型的系统按业务聚合关系拆分为若干微服务子系统。

就以电商为例，我们落地 `商户`、`商品`、`库存`、`会员`、`营销`、`订单`、`支付`、`物流`、`财务`等一系列的微服务。

每个微服务为了独立对外提供服务，都要分配个域名或者二级域名。另外每个业务子系统都需要集成流控、鉴权、黑白名单、签名、权限校验等通用组件功能。如果每个系统各自为战，自己造一套轮子，重新实现一遍，非常浪费。于是，我们会考虑是否可以将这些通用功能抽取出来，放到一个地方统一去去做。

于是就有了下面的系统架构，由网关接管所有的入口流量，类似 Nginx 的作用，将所有用户请求转发给后端的服务器。


<div align="left">
    <img src="https://offercome.cn/images/pay/arch/2-1.png" width="650px">
</div>


除了基础的转发功能，网关还会对流量做一些扩展，将这些通用的逻辑抽取出来，由网关统一去做。业务系统则更专注于业务逻辑的实现，大大提升迭代效率。

### 网关都有哪些核心功能？