---
title: 架构篇：DDD如何指导微服务落地
pay: https://articles.zsxq.com/id_ntik498b7j4s.html
---


#  架构篇：DDD如何指导微服务落地


> 作者：Tom哥
> <br/>公众号：微观技术
> <br/> 博客：[https://offercome.cn](https://offercome.cn)
> <br/> 人生理念：知道的越多，不知道的越多，努力去学


面对复杂的业务场景，拆分微服务构建分布式系统架构确实是一个不错的解决方案。但怎么拆，不同微服务间的边界在哪里？

一种方案是凭多年的行业经验积累，这个门槛很高，不管是谁，都是一个从零开始的过程。另一种方案，可以结合 DDD （领域驱动设计）的思想去指导微服务落地。

DDD本质上是一种软件设计方法，而微服务则是具体的实现方式。



## 核心概念

DDD 作为理论指导，有非常多的基础概念，如果想用好 DDD，我们需要先对这些概念有深入了解。然后，才能在业务实战中起到更好的指导作用。


<div align="left">
    <img src="https://offercome.cn/images/pay/arch/5-1.png" width="650px">
</div>


## 领域、子域

在研究和解决业务问题时，DDD 会按照一定的规则将业务领域进行细分，当领域细分到一定的程度后，DDD 会将问题范围限定在特定的边界内，在这个边界内建立领域模型，进而用代码实现该领域模型，解决相应的业务问题。简言之，DDD 的领域就是这个边界内要解决的业务问题域。