---
title: 作为技术团队TL，如何运用OKR提高团队产出
---

# 作为技术团队TL，如何运用OKR提高团队产出

> 作者：Tom哥
> <br/>公众号：微观技术
> <br/> 博客：[https://offercome.cn](https://offercome.cn)
> <br/> 人生理念：知道的越多，不知道的越多，努力去学


作为一个团队负责人，如何提升团队的产出？OKR可能会给出一些答案。

OKR诞生在Intel，随着Google的大规模使用而名声大噪。OKR作为一个科学的目标管理法，由O和KR两部分组成，其中O表示目标（Objective），KR表示关键结果（Key Result）。

如果采用数据ER图来描述，O和KR的关系是一对多。一个目标的实现，中间要经历一系列的过程，并产出一堆的关键结果。若干结果累积才达到最终的目标。


## 越来越多的公司推行OKR，那他的优势到底是什么？


* 目标明确，与公司的战略规划高度一致
* 关键节点拆解，由执行人自己来设定，全员透明
* 员工自己来实现自己定义的目标，有极强的参与感和责任感。


## KPI与OKR的区别是什么？

kpi全称 Key Performance Indicator，翻译过来是关键绩效指标，kpi的绩效指标一般只看结果，不关心过程，只要结果拿到了即可，其实很多公司都是类似的管理风格，采用一刀切的方式，看似考核方式简单、可控、易衡量，但是却伤害了团队的积极性。导致一些人投机取巧，眼里只看到最终的KPI考核结果，完全无视中间的过程，”为了完成KPI任务，不择手段“，甚至会做一些伤害用户体验、毁坏公司形象的事情。

而OKR却恰恰相反，更多的关心过程，有过程有结果，为过程喝彩为结果买单，从一系列的中间结果判断目标的达成情况。

> 小贴士：带团队最重要的是，平等、尊重，千万不要搞什么”一言堂“，要善于引导团队的小伙伴，主动思考，拿到结果。我们不是规则的制定者，而是要做一名”教练型“领导者。


## 如何制定OKR？

OKR中的O，主要是解决”做什么“问题。一定要有很强的激励作用，鼓舞人心。比如，将O制定为”打造一个营销中台“，很难起到鼓舞团队的作用。但如果定义成”打造一个易扩展、高性能、可复用，人人称赞的营销中台“，是不是就能很好的给团队打一针鸡血。

另外O一定要具备短期内可实现，避免假大空，或者上升到公司战略，短期内很难实现，会给人一种挫败感。

**制定O时，要注意三条核心原则**

* O要有实际价值，一定要深度思考
* 能激励人心，要善于表达
* 要脚踏实地，短期内可以实现


KR 是针对 OKR 中“How”的层面，它解决了具体“怎么做”的问题。KR最好可以量化，用数据说话。KR的设定要有一定的挑战难度，其中的”度“一定要把握好，KR挑战不够，会丧失OKR的原动力。KR难度过高，会挫伤我们的自信心，造成挫败感。所以KR制定一定要合适，踮一踮脚才能实现，这样慢慢给自己加码，提更高的要求，切勿拔苗助长。


## 持续跟踪OKR的落地执行

OKR制定一般一周时间差不多可以完成，接下来的核心就是执行。在推动执行过程中，可能会遇到一些阻碍。如果不及时调整，到了后面的OKR评分环节，会比较尴尬。

针对OKR的刷新和同步不及时问题，建议我们每天更新自己的 OKR 完成进度，每周对自己的 OKR 做一次回顾，每月对自己的 OKR 做一次优化，每季对团队和个人的 OKR 分别做一次复盘，逐渐养成习惯。建议在周会上定期同步自己的OKR执行进度，做到信息透明、共享，让每位团队成员都能收获成长的快乐。

将OKR无缝整合到你的日常工作中，将任务与 OKR 之间看成是一个“二级驱动”关系，即任务驱动 KR 的完成，进而促使 KR 驱动 O 的达成。

<div align="left">
    <img src="https://offercome.cn/images/team/manage/2-1.png" width="700px">
</div>


## OKR评估

首先会进行自评环节，每个人对自己的KR进行评分，最终的平均分就是OKR的最终评分。然后由主管对自己的OKR完成情况进行评分。

**OKR 评分 = 自我评分 x 20% + 同事评分 x 30% + 主管评分 x 50%**

然后对团队成员的OKR评分做一个排名，按 2：7：1 比例。2表示排名靠前20% 的人。该排名直接影响到个人的奖金额度。


## OKR复盘

考核不是最终目的，发现问题并最终解决问题才是我们的终极目标。我们工作中、项目中经常听到复盘，复盘其实是一个围棋术语，指的是棋手双方在棋局对战结束后，针对每一步棋是如何走的，做一个深入的思考和交流。

**复盘步骤**

* 审视目标：为何当初你要制定这样的目标，而不是其他目标？你所制定的目标现在达成了吗？如果没达成，现实和预期之间的差距之处在哪里呢？
* 回顾过程：就整个目标的执行过程而言，你是如何执行的？你大致分为几个阶段去执行？每个阶段中发生了哪些重要事件？
* 分析得失：在这次实施 OKR 周期中，哪些方面你做得很好？为什么好？哪些方面你做得不好？为什么不好？
* 总结规律：如果再次做同类事情，你会怎么去做？通过这次交流，对我们开展后续的工作有何指导？我们收获了哪些规律、原则、方法论？


## OKR如何向上管理

管理分为向上管理、向下管理、横向管理。向下管理指的是管理自己的团队，向上管理指的是与自己的领导有效沟通；横向管理指的是与自己的跨部门同事进行工作协同。

向下管理难度会小一些，毕竟你是老板，团队成员向你汇报，你有团队管理权力，相对会容易一些。向上管理、横向管理，由于管理对象并不需要向你汇报工作，当与他们进行工作协同时，存在一定的阻碍因素，可能无法按照自己的想法顺利推进工作进度。

向上管理，管理的其实是领导对你的期望。扪心自问，在跟领导的沟通过程中，是否真的明白了领导对你的期望？其实，很多下属都没有真正搞清楚这一点，就像很多产品经理没弄明白用户对产品的需求一样。所以，向上管理就需要你多跟上级沟通和确认，尤其是在一些重要工作的沟通和决策上，当双方理解完全一致后，再去落地执行。

很多老板有一些自己的想法，比如要求公司全员996加班，对于这种看似无理的要求，如何化解？可以考虑试下OKR，加班只是表象，更深层次讲老板想要的是产出、人效，所以通过制定OKR，提升团队的工作效率、结果输出，即使不加班，也能达到加班的效果，老板和员工皆大欢喜，何乐而不为。

小贴士：OKR不仅仅是一个工具，OKR是一种思维，当你需要向上管理时，OKR是你和老板沟通的”共同语言“。


## OKR如何打破部门墙

企业内部之间存在一堵无形的“墙”，它阻碍着跨部门协同，阻碍着各部门之间信息传递和工作交流，我们称这堵墙为“部门墙”，正是由于“部门墙”的产生，才导致公司缺乏执行效率，战略无法迅速落地。

部门墙导致部门间协同能力越来越弱，出现”各人自扫门前雪，哪管他人瓦上霜“。只关心各自部门的利益，打各种小算盘。

最终受伤还是公司、个人。针对这种情况，我们通常会采用业务单元制，从各个职责岗位圈人来组成虚拟项目团队，由业务单元负责人对项目结果最终负责。

<div align="left">
    <img src="https://offercome.cn/images/team/manage/2-2.png" width="700px">
</div>


从考核来看，业务单元以项目为导向，与结果高度匹配，很容易衡量绩效。职能团队是一个虚拟组织，它存在的价值在于加强业务单元间的联系，让团队伙伴们感觉到更有归属感，职能团队负责人将主要精力投入到提升人才技能的培养上。与其说是职能团队负责人，不如说是职能团队的“教练”，他使用 OKR 工作法来帮助团队伙伴们制定个人目标，扮演职能团队的“OKR 教练”。


> 小贴士：关注员工成长也是一种激励，而且比金钱激励效果更好，被激励的时间也更加长久。