---
title:  团队管理那点破事！OKR绩效、核心人才、面试、技术分享、研发流程....
---

# 团队管理那点破事！OKR绩效、核心人才、面试、技术分享、研发流程....

> 作者：Tom哥
> <br/>公众号：微观技术
> <br/> 博客：[https://offercome.cn](https://offercome.cn)
> <br/> 人生理念：知道的越多，不知道的越多，努力去学



## 团队管理

大家好，我是Tom哥~

今天来聊聊团队管理，可能你现在还是一线开发，没有带团队，感觉这个话题与你无关，其他不然。

程序员的职业生涯曲折，技术更新迭代快，走技术深度，走架构师路线，势必要付出常人的时间和精力。而管理则可以更好的复用之前经验。

知其然，知其所以然。现在，对管理拒绝的人总有一天，你会经历思想转变。

作为管理者，我们平时都会遇到哪些问题？又是如何来解决这些问题？好的经验我们要学会借鉴，来看看今天要聊的问题概要


<div align="left">
    <img src="https://offercome.cn/images/team/manage/10-1.jpg" width="600px">
</div>

## 做为团队负责人，你是如何带领团队？

答案：

* 1、角色认知、心态转变，“管人”和“理事”，借助团队拿结果 
* 2、OKR、KPI考核   
* 3、平衡好技术和业务发展矛盾 
* 4、技术储备和未来的技术规划，为业务预留空间  
* 5、知人善任，人才梯度培养  
* 6、方向要对、格局要大，与公司战略保持一致 
* 7、制定好团队目标  
* 8、技术分享，培养团队的技术氛围  
* 9、团建  
* 10、以人为本，激发每个人的积极性
* 更多内容，参考 [第一次带团队，感觉很慌怎么办？](https://mp.weixin.qq.com/s/EyjZkqXLAWhAC96liN36CQ)

## 开发规范流程，需要做哪些事情？

答案：

* 严格约定团队的开发规范，如：IDE 代码模板、命名规范(mysql建表、redis key 前缀，以及application.properties中的各种配置项，可以参考阿里代码规约)，代码ci规范，API命名，统一日志规范，MySQL建表
* 严格的开发流程，如：需求评审、技术方案设计、方案评审、测试用例评审、编码、代码 Review、测试、发布，线上发布要注意灰度。回滚机制
* 对于一些通用的逻辑，要注意抽取公共模块
* 技术框架选型要有严格流程

## 团队未来规划，负责人要怎么做？

答案：这个分为两部分。

* 一个是了解系统状况，有哪些历史技术债务（如：架构优化、性能优化、高可用、可伸缩等）需要分阶段偿还，提前做好时间安排。
* 提前了解业务规划，为了实现业务目标，我们要做哪些技术储备


## 如何让自己的团队高效且有战斗力？

答案：

* 1、业务支撑。按优先级将业务分为重点项目、日常项目。优先保证核心项目所需的开发资源。另外，经常与业务同学互通业务想法，提前做好技术储备。
* 2、骨干拉平。对团队经常组织技术培训，核心的技术骨干能轮动工作内容，每个系统都有人员互补。遇到紧急项目时，一个骨干+几个研发，就可以快速支撑一个项目。
* 3、架构升级，为业务预留技术储备。如：分布式、服务化、中台、中心化、中间件、平台化等
* 4、工程效率。包括动态化、配置化、工具化、自动化
* 5、系统稳定性。构建完善的报警监控系统、流控、熔断、降级、容灾、回滚、灰度，保障系统的稳定性。
* 更多内容，[如何打造一个高效的研发团队](https://mp.weixin.qq.com/s/ZVXG7tVvEPnyZslHIhObmg)


## 如何定制高效的研发流程？

答案：流程可以帮助我们更规范的做事情，提高整体的工作效率，进而提高产出。

* 产品层面，统一将业务需求收集到“需求池”中，每周定期 review 需求，将一些优先级较高的需求整合、立项、排期
* RPD 方案编写，包括界面、功能、逻辑、交互等
* PRD 方案评审，包括业务准确性、技术可行性评估
* 编写技术方案，并组织评审
* 项目计划，开发任务分解，人力成本，时间评估
* 各角色（前端、后端、客户端等）进入开发阶段，组织每日站立晨会，跟进项目遇到的问题，并及时做出调整。
* 代码 review，对不合理的地方及时调整
* 功能测试、性能测试、集成测试
* 预发环境检验
* 发布上线
* 项目经验总结


## 如何营造团队的技术氛围？

答案：物以类聚，人以群分。大到一个公司，小到一个团队，都有自己的味道。如果【味道】缺失，那团队的稳定性存在极大风险。

* 技术分享，输出倒逼输入，锻炼分享人的演讲能力，同时还能提高团队的整体技术能力
* 代码CR，可以点对点审查，也可以团队成员一起审查。既能保证代码质量，还能让大家对系统进一步了解
* 代码好坏味道，组织一些活动，对于一些优秀的代码、坏代码，拿出来通晒
* 读书会。一个人的成长离不开持续的学习输入。招聘的候选人要有很强的学习热情，有较强的自律性。
* 鼓励创新，紧跟市场前沿，对于一些新技术在充分验证可行性后，可以引入到工作中。当然，创新是有风险的，管理者要充分衡量利弊。
* 推行自动化，工具化。管理者要鼓励工程师创造工具、引入工具，释放一些低效工作。

建立和维护好团队的技术氛围，需要自上而下的技术导向，需要各级老板的鼎力支持，需要每位团队成员参与其中、融入其中，



## 如何做团队的绩效管理？

答案：肯定要引入一些科学管理方法，比如：KPI、OKR。kpi全称 Key Performance Indicator，只看结果，不关心过程，只要结果拿到了即可，适合销售、运营等考核指标相对明确的岗位。研发岗推荐使用OKR，根据目标自己定义关键节点的Key Result，更加能激发个人的主动性。

使用OKR工具，要关注几个点：

* 1、如何制定OKR？目标一定要清晰明确，有很强的激励作用，振奋人心；有实际价值；通过自己的努力，短期内可以实现。
* 2、持续跟踪OKR的落地执行，每周、每月、每季度都要定期回顾，不断优化对齐目标，做到信息透明、共享，让每位团队成员都能收获成长的快乐。
* 3、OKR评估，分为自评、主管打分。OKR 评分 = 自我评分 x 20% + 同事评分 x 30% + 主管评分 x 50%
* 4、OKR复盘。考核不是最终目的，发现问题并最终解决问题才是我们的终极目标。
* 更多内容，参考之前文章  [作为技术团队TL，如何运用OKR提高团队产出](https://mp.weixin.qq.com/s/yughLUWnXJeEnV32imKvcw)


## 如何做一个合格的面试官？

答案：

* 首先，了解招聘岗位的工作职责，技能要求，岗位定级，清楚招聘的候选人要具备什么能力
* 简历筛选，对于一些不太确定的可以约现场聊聊，毕竟人才稀缺
* 面试前，提前浏览下候选人的简历，了解其过往项目经历，这样短期内更容易全面考察候选人
* 面试不应该只局限技术，关于沟通力、团队协作、职业规划、价值观等软性方面也要考察
* 面试尾声，可以问问候选人有什么想了解的？ 毕竟清楚彼此双方核心诉求，才能更长远合作
* 面试结束后，及时填写面试反馈，便于后续流程推进



## 如何招到核心人才？

答案：核心人才主要关注两点：

* 1、价值观。如果员工的价值观与公司不符，即使能力再强，也很难融入集体，创造价值。
* 2、技术能力。这个主要是通过两个方面来把控。一个是入职的技术面试，一般有2~4轮，甚至还有部门交叉面试，全方位了解候选人的技术实力。另一个是，由于候选人之前的工作经历和方向与新工作存在一定差异性，候选人能否快速适应新工作环境，所以，会有一个试用期，试用期会制定一个考核目标，直接主管和HRBP 会定期与候选人沟通，答疑解惑，帮助候选人快速投入新的工作中。


## 如何留住核心人才？

答案：做产品是为了满足用户需求。内部员工也是一样，**先成就员工，再成就团队，最后成就企业**。给每个员工足够的成长机会，让他对公司有归属感，找到自己的目标与追求。

对症下药，清楚了解每个员工的诉求点：提升自身技术水平、升职加薪、想带团队。。。等，工作中尽量照顾核心员工的需求，让他们工作中能保持愉悦心态，并获得成就感。

人嘛，干什么事都要有新鲜感，也可以尝试技术轮岗，接触一些新的东西，既开阔了员工视野，也可能碰撞出一些新的火花。

当然，作为直接负责人，你就是团队成员的天花板，所以也要严格要求自己，不断提升自己的技术能力、视野和管理能力，承担更大的职责，给团队成员预留足够的上升空间。


## 什么样的员工坚决开除？

答案：

* 试用期制定了明确的考核目标，考核周期结束后不能很好的完成
* 踩到公司的红线，比如贪污受贿、数据泄密、威胁公司信息安全
* 态度傲慢，很难与其他同事协同工作，这种人即使能力再强，也坚决开除。因为我们是团队作战，不是搞个人英雄主义。
* 不认同公司的价值观，个人的品质较差


## 什么样的员工，老板喜欢？

答案：有人可能说，“不要工资，干活卖力！”，严肃点，不要皮

* 做事细心，考虑问题全面，工作效率高。
* 工作踏实，不挑活
* 有强烈的责任心，接手一件事情，有一杆到底的精神
* 除了做好本职工作外，还会考虑系统架构优化或产品生态建设的工作，有强烈的上进心
* 善于沟通，有很强的团队协同能力

## 如何做好团队的激励？

答案：人是一种复杂动物，而且每个人的诉求都不一样，如何统一激励框架就显得非常重要。

我们要找到激发员工的工作动机，用各种有效的方法来调动员工的积极性和创造性，使其完成任务。比如，现在流行的OKR 管理，自己设定目标以及关键 Key Result，并在团队中共享，做到公开透明，这样每个人都清楚了解团队的目标方向，自己在哪一个位置，起什么作用，让每个成员有强烈的参与感、掌控感，更容易激发员工的主观能动性。

具体的激励一般有以下几种：

* 精神激励。领导的信任表扬；对自身价值的认同。低成本、高效率。比如：每月之星、光荣榜、各种奖项
* 晋升激励。
* 物质激励，股票、期权、项目奖、季度奖、年终奖等
* 量身定做，团队成员的情况千差万别，可以结合马斯洛理论，充分了解员工的情况，为员工定制化。


## 作为团队负责人，如何面对压力？

答案：岗位越高，承担的职责就越大，接受的挑战和压力就越大。

* 分阶段、分里程碑的方式来制定计划，逐步完成事项来达成目标。给自己留一些缓冲时间，以便于应对计划的灵活性调整。
* 时刻保持旺盛的精力，保持跟团队成员的沟通，了解他们的工作状态和感受
* 敢于面对上层传递下来的压力，做好缓冲，避免团队过于透支，保证有一个稳固的后方。
* 做好项目时间计划表，分清项目的优先级、重要性，合理安排，统筹管理
* 学会委派工作。知人善任，合理分工，发挥团队的力量，而不是当一个超级英雄
* 放松心态，工作和生活尽量分开，保证充足的睡眠和锻炼，毕竟身体是革命的本钱。


## 参考资料

* [个人成长与职业规划](https://github.com/aalansehaiyang/p-technology-talk/blob/master/other/person.md)
* [第66讲 | 如何打造有活力、持续创新的研发团队？](https://time.geekbang.org/column/article/12810)